import { Component, OnInit, OnDestroy } from "@angular/core";
import { Subscription } from 'rxjs';

import { NgForm } from "@angular/forms";

import { Post } from "../post.model";
import { PostsService } from "../posts.service";
import { max } from "rxjs/operators";

@Component({
  selector: "app-post-list",
  templateUrl: "./post-list.component.html",
  styleUrls: ["./post-list.component.css"]
})

export class PostListComponent implements OnInit, OnDestroy {
  posts: Post[] = [];
  maxPosts: Post[] = [];
  private postsSub: Subscription;


  constructor(public postsService: PostsService) {}

  ngOnInit() {
    this.postsService.getPosts();
    this.postsSub = this.postsService.getPostUpdateListener().subscribe((posts: Post[]) => {
      this.posts = posts.slice(0,100);
      this.maxPosts = posts;
      //this.posts = this.maxPosts.slice(0,100);
    });
  }

  onSearch(form: NgForm) {
    console.log(form.value.search);
    if (!form.value.search) {
      location.reload();
    } else {
      var tempList = []
      for (var i = 0; i < this.posts.length; i++) {
        var testString = this.maxPosts[i].title;
        var formInput = form.value.search;
        console.log(testString, formInput);
        if (testString.match(formInput)) {
          var temp = this.maxPosts[i];
          tempList.push(temp);
        }
      } this.posts = tempList;
    }
  }

  ngOnDestroy() {
    this.postsSub.unsubscribe();
  }
}
